/*
 * integrate.hpp
 *
 *  Created on: Jun 17, 2024
 *      Author: Dario
 */

#ifndef STA_MATHS_ATTITUDE_INTEGRATE_HPP
#define STA_MATHS_ATTITUDE_INTEGRATE_HPP

#include <sta/math/quaternion.hpp>
#include <sta/time.hpp>


namespace sta
{
	namespace math
	{
		class AttitudeModel
	    {
	    public:
	        AttitudeModel(Quaternion state, float alpha = 1.0f);

	        Quaternion update(float dt, float ox, float oy, float oz);

	        Quaternion update(float ox, float oy, float oz);

	        Quaternion getAttitude();
	    private:
	        Quaternion state_;
	        float ox_, oy_, oz_;
	        float alpha_;
	        float time_;
	    };
	}  // namespace math
} // namespace sta

#endif // STA_MATHS_ATTITUDE_INTEGRATE_HPP
