#include <sta/math/algorithms/rollingAverage.hpp>

namespace sta
{
	namespace math
	{
		template <typename T>
		RollingAverage<T>::RollingAverage(int size)
			: size_(size), values_(nullptr), index_(0), sum_(0)
		{
			values_ = new Value[size];
			for (int i = 0; i < size; i++)
			{
				values_[i] = 0;
			}
		}

		template <typename T>
		RollingAverage<T>::~RollingAverage()
		{
			delete values_;
		}

		template <typename T>
		void RollingAverage<T>::add(Value value)
		{
			sum_ -= values_[index_];
			values_[index_] = value;
			sum_ += value;
			index_ = (index_ + 1) % size_;
		}

		template <typename T>
		typename RollingAverage<T>::Value RollingAverage<T>::get()
		{
			return sum_ / size_;
		}

	} // namespace math

} // namespace sta
